"use strict";

var _vue = require("vue");

var _expect = _interopRequireDefault(require("expect"));

var _utils = require("./utils");

var _templateObject, _templateObject2, _templateObject3;

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _taggedTemplateLiteral(strings, raw) { if (!raw) { raw = strings.slice(0); } return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); }

var styled;
describe('"as" polymorphic prop', function () {
  beforeEach(function () {
    styled = (0, _utils.resetStyled)();
  });
  it('should render "as" polymorphic prop element', function () {
    var Base = styled.div(_templateObject || (_templateObject = _taggedTemplateLiteral(["\n      color: blue;\n    "])));
    var b = (0, _vue.createApp)({
      render: function render() {
        return (0, _vue.h)(Base, {
          as: 'button'
        });
      }
    }).mount('body');
    (0, _expect["default"])(b.$el.tagName.toLowerCase()).toEqual('button');
  });
  it('should append base class to new components composing lower level styled components', function () {
    var Base = styled.div(_templateObject2 || (_templateObject2 = _taggedTemplateLiteral(["\n      color: blue;\n    "])));
    var Composed = styled(Base, {
      bg: String
    })(_templateObject3 || (_templateObject3 = _taggedTemplateLiteral(["\n      background: ", ";\n    "])), function (props) {
      return props.bg;
    });
    var b = (0, _vue.createApp)(Base).mount('body');
    var c = (0, _vue.createApp)({
      render: function render() {
        return (0, _vue.h)(Composed, {
          bg: 'yellow',
          as: 'dialog'
        });
      }
    }).mount('body');
    (0, _expect["default"])(c.$el.tagName.toLowerCase()).toEqual('dialog');
    (0, _expect["default"])(c.$el.classList.contains(b.$el.classList.toString())).toBeTruthy();
    (0, _utils.expectCSSMatches)('.a{color: blue;} .b{background:yellow;}');
  });
});