"use strict";

var _vue = require("vue");

var _expect = _interopRequireDefault(require("expect"));

var _StyleSheet = _interopRequireDefault(require("../models/StyleSheet"));

var _utils = require("./utils");

var _templateObject, _templateObject2, _templateObject3, _templateObject4, _templateObject5, _templateObject6;

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _taggedTemplateLiteral(strings, raw) { if (!raw) { raw = strings.slice(0); } return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); }

var styled;
describe('basic', function () {
  beforeEach(function () {
    styled = (0, _utils.resetStyled)();
  });
  it('should not throw an error when called', function () {
    styled.div(_templateObject || (_templateObject = _taggedTemplateLiteral([""])));
  });
  it('should inject a stylesheet when a component is created', function () {
    var Comp = styled.div(_templateObject2 || (_templateObject2 = _taggedTemplateLiteral([""])));
    var vm = (0, _vue.createApp)(Comp).mount('body');
    (0, _expect["default"])(_StyleSheet["default"].injected).toBe(true);
  });
  it('should not generate any styles by default', function () {
    styled.div(_templateObject3 || (_templateObject3 = _taggedTemplateLiteral([""])));
    (0, _utils.expectCSSMatches)('');
  });
  it('should throw an error when called', function () {
    (0, _expect["default"])(function () {
      return styled(_templateObject4 || (_templateObject4 = _taggedTemplateLiteral([""])));
    }).toThrow();
    (0, _expect["default"])(function () {
      return styled.notExistTag(_templateObject5 || (_templateObject5 = _taggedTemplateLiteral([""])));
    }).toThrow();
  });
  it('should allow for inheriting components that are not styled', function () {
    var componentConfig = {
      name: 'Parent',
      template: '<div><slot/></div>',
      methods: {}
    };
    (0, _expect["default"])(function () {
      return styled(componentConfig, {})(_templateObject6 || (_templateObject6 = _taggedTemplateLiteral([""])));
    }).not.toThrow();
  });
});